---
title: Adding Files to the Build
slug: Mozilla/Developer_guide/Build_Instructions/Adding_Files_to_the_Build
tags:
  - Build documentation
  - Developing Mozilla
---
<p>All platforms are using the same set of makefiles for the build so all you have to do is edit <code>Makefile.in</code> files (and possibly <code>toolkit/toolkit-tiers.mk</code> if you add new makefiles).</p>

<p>{{ Note("Don\'t forget to check TreeHerder after you check in!") }}</p>

<h2 id="Adding_files_to_the_build">Adding files to the build</h2>

<ul>
 <li>Edit <code class="filename">Makefile.in</code> files to add new source files, and export header files.</li>
 <li>Dependencies are specified in <code class="filename">Makefile.in</code> too</li>
 <li>If you add a new directory to the build, you have to add the directory to the list of subdirectories in <code class="filename">../Makefile.in</code>.</li>
 <li>Some directories are special, and you need to list new directories in <code>toolkit/toolkit-tiers.mk</code>. The files listed here are not specific to the <code>toolkit/</code> directory, so if your makefile is not yet being processed correctly, try to add it here.</li>
 <li>On platforms that build with <code>gcc</code>, because of the symbol visibility, you might have to check <a href="/en/System_Headers" title="en/System_Headers">System Headers</a> to make sure they are properly wrapped.</li>
</ul>

<h2 id="Checking_In">Checking in</h2>

<p>Adding new files to the build can cause breakage on tinderbox and to other developers if things aren't checked in the correct order.</p>

<ol>
 <li>Check in only the new files.</li>
 <li>Check in the patches to existing files that make your new files get used.</li>
</ol>

<h2 id="Exporting_Files">Exporting files</h2>

<p>Exporting a file makes it get copied to <code>mozilla/dist</code>. C and C++ header files are exported by including them the <code>EXPORTS</code> list in {{ Source("xpcom/base/Makefile.in#60", "Makefile.in") }}, and IDL files are exported by including them in the <code>XPIDLSRCS</code> list.</p>

<p>Original Document Information</p>

<div class="originaldocinfo">
<ul>
 <li>Author(s): <a class="link-mailto" href="mailto:akkana@netscape.com">Akkana Peck</a></li>
 <li>Last Updated Date: May 28, 2007</li>
 <li>Copyright Information: Portions of this content are © 1998–2007 by individual mozilla.org contributors; content available under a Creative Commons license | <a class="external" href="http://www.mozilla.org/foundation/licensing/website-content.html">Details</a>.</li>
</ul>
</div>
